
mini_32siors_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;mini siors.mbas,55 :: 		sub procedure interrupt
;mini siors.mbas,57 :: 		if tmr1_interrupt then
	BTFSS      PIR1+0, 0
	GOTO       L_mini_32siors_interrupt2
;mini siors.mbas,59 :: 		tmr1_interrupt = 0
	BCF        PIR1+0, 0
;mini siors.mbas,63 :: 		if (count_tmr1 = delay_set) then
	MOVF       _count_tmr1+1, 0
	XORWF      _delay_set+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L_mini_32siors_interrupt150
	MOVF       _delay_set+0, 0
	XORWF      _count_tmr1+0, 0
L_mini_32siors_interrupt150:
	BTFSS      STATUS+0, 2
	GOTO       L_mini_32siors_interrupt5
;mini siors.mbas,65 :: 		tmr1_enable = 0
	BCF        T1CON+0, 0
;mini siors.mbas,66 :: 		tmr1h = 0
	CLRF       TMR1H+0
;mini siors.mbas,67 :: 		tmr1l = 0
	CLRF       TMR1L+0
;mini siors.mbas,69 :: 		count_tmr1 = 0
	CLRF       _count_tmr1+0
	CLRF       _count_tmr1+1
;mini siors.mbas,72 :: 		reset_pulse.0 = 1
	BSF        _reset_pulse+0, 0
	GOTO       L_mini_32siors_interrupt6
;mini siors.mbas,73 :: 		else 'altrimenti incremento count_tmr1
L_mini_32siors_interrupt5:
;mini siors.mbas,74 :: 		count_tmr1 = count_tmr1 + 1
	INCF       _count_tmr1+0, 1
	BTFSC      STATUS+0, 2
	INCF       _count_tmr1+1, 1
;mini siors.mbas,75 :: 		end if
L_mini_32siors_interrupt6:
L_mini_32siors_interrupt2:
;mini siors.mbas,76 :: 		end if
L_mini_32siors_interrupt149:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of mini_32siors_interrupt

mini_32siors_send_data:

;mini siors.mbas,80 :: 		sub procedure send_data(dim byref datasend as string[11])
;mini siors.mbas,81 :: 		last_send_data = datasend
	MOVLW      _last_send_data+0
	MOVWF      FSR
	MOVF       FARG_send_data_datasend+0, 0
	MOVWF      R1+0
	CALL       ___CS2S+0
	CLRF       INDF+0
;mini siors.mbas,82 :: 		led_activity = 1 'accendo led
	BSF        PORTB+0, 3
;mini siors.mbas,83 :: 		delay_ms(10)'Attende il rilascio del bus
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_mini_32siors_send_data8:
	DECFSZ     R13+0, 1
	GOTO       L_mini_32siors_send_data8
	DECFSZ     R12+0, 1
	GOTO       L_mini_32siors_send_data8
	NOP
	NOP
;mini siors.mbas,84 :: 		tx_uart_enable = 1 'abilita invio seriale
	BSF        TXSTA+0, 5
;mini siors.mbas,85 :: 		RS485_bus_direction = 1 'seleziona la direzione di comonicazione (invio)
	BSF        PORTB+0, 0
;mini siors.mbas,86 :: 		delay_us(400) 'attende attivazione max485
	MOVLW      133
	MOVWF      R13+0
L_mini_32siors_send_data9:
	DECFSZ     R13+0, 1
	GOTO       L_mini_32siors_send_data9
;mini siors.mbas,87 :: 		UART1_Write_Text(datasend) 'invia la stringa generata
	MOVF       FARG_send_data_datasend+0, 0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	CALL       _UART1_Write_Text+0
;mini siors.mbas,88 :: 		delay_ms(2) 'attende invio segnali
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_mini_32siors_send_data10:
	DECFSZ     R13+0, 1
	GOTO       L_mini_32siors_send_data10
	DECFSZ     R12+0, 1
	GOTO       L_mini_32siors_send_data10
	NOP
	NOP
;mini siors.mbas,89 :: 		led_activity = 0 'disattivo led
	BCF        PORTB+0, 3
;mini siors.mbas,90 :: 		RS485_bus_direction = 0 'ritorno in modalit ascolto
	BCF        PORTB+0, 0
;mini siors.mbas,91 :: 		tx_uart_enable = 0 'disabilita invio seriale
	BCF        TXSTA+0, 5
	RETURN
; end of mini_32siors_send_data

mini_32siors_code_data_to_send:

;mini siors.mbas,103 :: 		dim address_slave_send as byte
;mini siors.mbas,104 :: 		type_to_send = type_s * 4 'sposto di 2 bit la parte del tipo di paccketto
	MOVF       FARG_code_data_to_send_type_s+0, 0
	MOVWF      code_data_to_send_type_to_send+0
	RLF        code_data_to_send_type_to_send+0, 1
	BCF        code_data_to_send_type_to_send+0, 0
	RLF        code_data_to_send_type_to_send+0, 1
	BCF        code_data_to_send_type_to_send+0, 0
;mini siors.mbas,105 :: 		if (address_master_send <> 255) then 'se l'indirizzo  in modalit normale
	MOVF       FARG_code_data_to_send_address_master_send+0, 0
	XORLW      255
	BTFSC      STATUS+0, 2
	GOTO       L_mini_32siors_code_data_to_send13
;mini siors.mbas,106 :: 		address_slave_send = adr_s
	MOVF       _adr_s+0, 0
	MOVWF      code_data_to_send_address_slave_send+0
	GOTO       L_mini_32siors_code_data_to_send14
;mini siors.mbas,107 :: 		else 'altriemtni se in broadcast
L_mini_32siors_code_data_to_send13:
;mini siors.mbas,108 :: 		address_slave_send = 255
	MOVLW      255
	MOVWF      code_data_to_send_address_slave_send+0
;mini siors.mbas,109 :: 		end if
L_mini_32siors_code_data_to_send14:
;mini siors.mbas,110 :: 		if (data1_s = 0) then 'se data1  pari a 0
	MOVF       FARG_code_data_to_send_data1_s+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_mini_32siors_code_data_to_send16
;mini siors.mbas,111 :: 		data_send_1 = 48 'invio 48 e segno con il bit in type to send che  uno 0
	MOVLW      48
	MOVWF      code_data_to_send_data_send_1+0
;mini siors.mbas,112 :: 		type_to_send.0 = 1
	BSF        code_data_to_send_type_to_send+0, 0
	GOTO       L_mini_32siors_code_data_to_send17
;mini siors.mbas,113 :: 		else
L_mini_32siors_code_data_to_send16:
;mini siors.mbas,114 :: 		data_send_1 = data1_s  'altrimenti mantengo il dato
	MOVF       FARG_code_data_to_send_data1_s+0, 0
	MOVWF      code_data_to_send_data_send_1+0
;mini siors.mbas,115 :: 		end if
L_mini_32siors_code_data_to_send17:
;mini siors.mbas,116 :: 		if (data2_s = 0) then 'se data2  pari a 0
	MOVF       FARG_code_data_to_send_data2_s+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_mini_32siors_code_data_to_send19
;mini siors.mbas,117 :: 		data_send_2 = 48 'invio 48 e segno con il bit in type to send che  uno 0
	MOVLW      48
	MOVWF      code_data_to_send_data_send_2+0
;mini siors.mbas,118 :: 		type_to_send.1 = 1
	BSF        code_data_to_send_type_to_send+0, 1
	GOTO       L_mini_32siors_code_data_to_send20
;mini siors.mbas,119 :: 		else
L_mini_32siors_code_data_to_send19:
;mini siors.mbas,120 :: 		data_send_2 = data2_s 'altrimenti mantengo il dato
	MOVF       FARG_code_data_to_send_data2_s+0, 0
	MOVWF      code_data_to_send_data_send_2+0
;mini siors.mbas,121 :: 		end if
L_mini_32siors_code_data_to_send20:
;mini siors.mbas,123 :: 		checksum_send = address_master_send xor address_slave_send xor type_to_send xor data_send_1 xor data_send_2
	MOVF       code_data_to_send_address_slave_send+0, 0
	XORWF      FARG_code_data_to_send_address_master_send+0, 0
	MOVWF      R0+0
	MOVF       code_data_to_send_type_to_send+0, 0
	XORWF      R0+0, 1
	MOVF       code_data_to_send_data_send_1+0, 0
	XORWF      R0+0, 1
	MOVF       code_data_to_send_data_send_2+0, 0
	XORWF      R0+0, 0
	MOVWF      R1+0
;mini siors.mbas,124 :: 		checksum_send_low = (checksum_send and 15) or 128
	MOVLW      15
	ANDWF      R1+0, 0
	MOVWF      _string_compose+6
	BSF        _string_compose+6, 7
;mini siors.mbas,125 :: 		checksum_send_hi =  (checksum_send / 16) or 128
	MOVF       R1+0, 0
	MOVWF      _string_compose+7
	RRF        _string_compose+7, 1
	BCF        _string_compose+7, 7
	RRF        _string_compose+7, 1
	BCF        _string_compose+7, 7
	RRF        _string_compose+7, 1
	BCF        _string_compose+7, 7
	RRF        _string_compose+7, 1
	BCF        _string_compose+7, 7
	BSF        _string_compose+7, 7
;mini siors.mbas,127 :: 		string_compose[0] = "S"
	MOVLW      83
	MOVWF      _string_compose+0
;mini siors.mbas,128 :: 		string_compose[1] = address_master_send
	MOVF       FARG_code_data_to_send_address_master_send+0, 0
	MOVWF      _string_compose+1
;mini siors.mbas,129 :: 		string_compose[2] = address_slave_send
	MOVF       code_data_to_send_address_slave_send+0, 0
	MOVWF      _string_compose+2
;mini siors.mbas,130 :: 		string_compose[3] = type_to_send
	MOVF       code_data_to_send_type_to_send+0, 0
	MOVWF      _string_compose+3
;mini siors.mbas,131 :: 		string_compose[4] = data_send_1
	MOVF       code_data_to_send_data_send_1+0, 0
	MOVWF      _string_compose+4
;mini siors.mbas,132 :: 		string_compose[5] = data_send_2
	MOVF       code_data_to_send_data_send_2+0, 0
	MOVWF      _string_compose+5
;mini siors.mbas,133 :: 		string_compose[6] = checksum_send_low
;mini siors.mbas,134 :: 		string_compose[7] = checksum_send_hi
;mini siors.mbas,135 :: 		string_compose[8] = 3 'byte di fine trama
	MOVLW      3
	MOVWF      _string_compose+8
;mini siors.mbas,136 :: 		string_compose[9] = 3
	MOVLW      3
	MOVWF      _string_compose+9
;mini siors.mbas,137 :: 		string_compose[10] = 3
	MOVLW      3
	MOVWF      _string_compose+10
;mini siors.mbas,138 :: 		string_compose[11] = 0 'carattere NULL
	CLRF       _string_compose+11
;mini siors.mbas,140 :: 		send_data(string_compose)
	MOVLW      _string_compose+0
	MOVWF      FARG_send_data_datasend+0
	CALL       mini_32siors_send_data+0
	RETURN
; end of mini_32siors_code_data_to_send

mini_32siors_decode_ric_data:

;mini siors.mbas,149 :: 		dim calcolated_checksum as byte
;mini siors.mbas,150 :: 		correct_data = 0
	MOVF       FARG_decode_ric_data_correct_data+0, 0
	MOVWF      FSR
	CLRF       INDF+0
;mini siors.mbas,151 :: 		if (array_in_data[0] = 83) then 'se start byte  corretto
	MOVF       FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      83
	BTFSS      STATUS+0, 2
	GOTO       L_mini_32siors_decode_ric_data23
;mini siors.mbas,154 :: 		chk_low = array_in_data[6] and 15
	MOVLW      6
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVLW      15
	ANDWF      INDF+0, 0
	MOVWF      R3+0
;mini siors.mbas,155 :: 		chk_hi = array_in_data[7] and 15
	MOVLW      7
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVLW      15
	ANDWF      INDF+0, 0
	MOVWF      R2+0
;mini siors.mbas,156 :: 		checksum = (chk_hi * 16) or chk_low 'mette insieme i 2 byte per ricostruire il byte di checksum
	MOVF       R2+0, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	IORWF      R3+0, 1
;mini siors.mbas,158 :: 		calcolated_checksum = array_in_data[1] xor array_in_data[2] xor array_in_data[3] xor array_in_data[4] xor array_in_data[5]
	INCF       FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      R1+0
	MOVLW      2
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORWF      R0+0, 1
	MOVLW      3
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORWF      R0+0, 1
	MOVLW      4
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORWF      R0+0, 1
	MOVLW      5
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORWF      R0+0, 1
;mini siors.mbas,159 :: 		if (calcolated_checksum = checksum) and (array_in_data[6].7 = 1) and (array_in_data[7].7 = 1) then 'se il checksum  corretto
	MOVF       R0+0, 0
	XORWF      R3+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
	MOVLW      6
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 7
	GOTO       L_mini_32siors_decode_ric_data28
	MOVLW      255
	MOVWF      R0+0
L_mini_32siors_decode_ric_data28:
	MOVF       R0+0, 0
	ANDWF      R2+0, 1
	MOVLW      7
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 7
	GOTO       L_mini_32siors_decode_ric_data29
	MOVLW      255
	MOVWF      R0+0
L_mini_32siors_decode_ric_data29:
	MOVF       R2+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L_mini_32siors_decode_ric_data26
;mini siors.mbas,160 :: 		address_ric = array_in_data[1]
	INCF       FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       FARG_decode_ric_data_address_ric+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;mini siors.mbas,161 :: 		address_master = array_in_data[2]
	MOVLW      2
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       FARG_decode_ric_data_address_master+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;mini siors.mbas,162 :: 		type_ric = (array_in_data[3] and 252)/4 'preleva il byte che seleziona il tipo di chiamata
	MOVLW      3
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVLW      252
	ANDWF      INDF+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	MOVF       FARG_decode_ric_data_type_ric+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;mini siors.mbas,164 :: 		if (array_in_data[4] = 48) and (array_in_data[3].0 = 1) then 'se data1  uguale a zero (controllo zero flag 1)
	MOVLW      4
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      48
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
	MOVLW      3
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 0
	GOTO       L_mini_32siors_decode_ric_data33
	MOVLW      255
	MOVWF      R0+0
L_mini_32siors_decode_ric_data33:
	MOVF       R2+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L_mini_32siors_decode_ric_data31
;mini siors.mbas,165 :: 		data1_ric = 0
	MOVF       FARG_decode_ric_data_data1_ric+0, 0
	MOVWF      FSR
	CLRF       INDF+0
	GOTO       L_mini_32siors_decode_ric_data32
;mini siors.mbas,166 :: 		else 'altrimenti viene copiato il byte
L_mini_32siors_decode_ric_data31:
;mini siors.mbas,167 :: 		data1_ric = array_in_data[4]
	MOVLW      4
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       FARG_decode_ric_data_data1_ric+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;mini siors.mbas,168 :: 		end if
L_mini_32siors_decode_ric_data32:
;mini siors.mbas,169 :: 		if (array_in_data[5] = 48) and (array_in_data[3].1 = 1) then 'se data2  uguale a zero (controllo zero flag 2)
	MOVLW      5
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      48
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
	MOVLW      3
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 1
	GOTO       L_mini_32siors_decode_ric_data37
	MOVLW      255
	MOVWF      R0+0
L_mini_32siors_decode_ric_data37:
	MOVF       R2+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L_mini_32siors_decode_ric_data35
;mini siors.mbas,170 :: 		data2_ric = 0
	MOVF       FARG_decode_ric_data_data2_ric+0, 0
	MOVWF      FSR
	CLRF       INDF+0
	GOTO       L_mini_32siors_decode_ric_data36
;mini siors.mbas,171 :: 		else 'altrimenti viene copiato il byte
L_mini_32siors_decode_ric_data35:
;mini siors.mbas,172 :: 		data2_ric = array_in_data[5]
	MOVLW      5
	ADDWF      FARG_decode_ric_data_array_in_data+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       FARG_decode_ric_data_data2_ric+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;mini siors.mbas,173 :: 		end if
L_mini_32siors_decode_ric_data36:
;mini siors.mbas,174 :: 		correct_data = 1
	MOVF       FARG_decode_ric_data_correct_data+0, 0
	MOVWF      FSR
	MOVLW      1
	MOVWF      INDF+0
L_mini_32siors_decode_ric_data26:
;mini siors.mbas,175 :: 		end if
L_mini_32siors_decode_ric_data23:
;mini siors.mbas,176 :: 		end if
	RETURN
; end of mini_32siors_decode_ric_data

mini_32siors_read_output:

;mini siors.mbas,180 :: 		sub procedure read_output()
;mini siors.mbas,181 :: 		out_value_r = $00
	CLRF       _out_value_r+0
;mini siors.mbas,182 :: 		out_value_r.0 = OUT1
	BTFSC      PORTA+0, 0
	GOTO       L_mini_32siors_read_output151
	BCF        _out_value_r+0, 0
	GOTO       L_mini_32siors_read_output152
L_mini_32siors_read_output151:
	BSF        _out_value_r+0, 0
L_mini_32siors_read_output152:
;mini siors.mbas,183 :: 		out_value_r.1 = OUT2
	BTFSC      PORTA+0, 1
	GOTO       L_mini_32siors_read_output153
	BCF        _out_value_r+0, 1
	GOTO       L_mini_32siors_read_output154
L_mini_32siors_read_output153:
	BSF        _out_value_r+0, 1
L_mini_32siors_read_output154:
;mini siors.mbas,184 :: 		out_value_r.2 = OUT3
	BTFSC      PORTA+0, 2
	GOTO       L_mini_32siors_read_output155
	BCF        _out_value_r+0, 2
	GOTO       L_mini_32siors_read_output156
L_mini_32siors_read_output155:
	BSF        _out_value_r+0, 2
L_mini_32siors_read_output156:
;mini siors.mbas,185 :: 		out_value_r.3 = OUT4
	BTFSC      PORTA+0, 3
	GOTO       L_mini_32siors_read_output157
	BCF        _out_value_r+0, 3
	GOTO       L_mini_32siors_read_output158
L_mini_32siors_read_output157:
	BSF        _out_value_r+0, 3
L_mini_32siors_read_output158:
	RETURN
; end of mini_32siors_read_output

mini_32siors_read_input:

;mini siors.mbas,188 :: 		sub function read_input() as byte
;mini siors.mbas,189 :: 		result = $FF
	MOVLW      255
	MOVWF      R1+0
;mini siors.mbas,190 :: 		result.0 = IN1
	BTFSC      PORTB+0, 4
	GOTO       L_mini_32siors_read_input159
	BCF        R1+0, 0
	GOTO       L_mini_32siors_read_input160
L_mini_32siors_read_input159:
	BSF        R1+0, 0
L_mini_32siors_read_input160:
;mini siors.mbas,191 :: 		result.1 = IN2
	BTFSC      PORTB+0, 5
	GOTO       L_mini_32siors_read_input161
	BCF        R1+0, 1
	GOTO       L_mini_32siors_read_input162
L_mini_32siors_read_input161:
	BSF        R1+0, 1
L_mini_32siors_read_input162:
;mini siors.mbas,192 :: 		result.2 = IN3
	BTFSC      PORTB+0, 6
	GOTO       L_mini_32siors_read_input163
	BCF        R1+0, 2
	GOTO       L_mini_32siors_read_input164
L_mini_32siors_read_input163:
	BSF        R1+0, 2
L_mini_32siors_read_input164:
;mini siors.mbas,193 :: 		result.3 = IN4
	BTFSC      PORTB+0, 7
	GOTO       L_mini_32siors_read_input165
	BCF        R1+0, 3
	GOTO       L_mini_32siors_read_input166
L_mini_32siors_read_input165:
	BSF        R1+0, 3
L_mini_32siors_read_input166:
	MOVF       R1+0, 0
	MOVWF      R0+0
	RETURN
; end of mini_32siors_read_input

mini_32siors_write_output:

;mini siors.mbas,197 :: 		sub procedure write_output(dim out_value_w as byte)
;mini siors.mbas,198 :: 		OUT1 = out_value_w.0
	BTFSC      FARG_write_output_out_value_w+0, 0
	GOTO       L_mini_32siors_write_output167
	BCF        PORTA+0, 0
	GOTO       L_mini_32siors_write_output168
L_mini_32siors_write_output167:
	BSF        PORTA+0, 0
L_mini_32siors_write_output168:
;mini siors.mbas,199 :: 		OUT2 = out_value_w.1
	BTFSC      FARG_write_output_out_value_w+0, 1
	GOTO       L_mini_32siors_write_output169
	BCF        PORTA+0, 1
	GOTO       L_mini_32siors_write_output170
L_mini_32siors_write_output169:
	BSF        PORTA+0, 1
L_mini_32siors_write_output170:
;mini siors.mbas,200 :: 		OUT3 = out_value_w.2
	BTFSC      FARG_write_output_out_value_w+0, 2
	GOTO       L_mini_32siors_write_output171
	BCF        PORTA+0, 2
	GOTO       L_mini_32siors_write_output172
L_mini_32siors_write_output171:
	BSF        PORTA+0, 2
L_mini_32siors_write_output172:
;mini siors.mbas,201 :: 		OUT4 = out_value_w.3
	BTFSC      FARG_write_output_out_value_w+0, 3
	GOTO       L_mini_32siors_write_output173
	BCF        PORTA+0, 3
	GOTO       L_mini_32siors_write_output174
L_mini_32siors_write_output173:
	BSF        PORTA+0, 3
L_mini_32siors_write_output174:
	RETURN
; end of mini_32siors_write_output

mini_32siors_reset_EEPROM_value:

;mini siors.mbas,205 :: 		sub procedure reset_EEPROM_value()
;mini siors.mbas,206 :: 		EEPROM_Write($02, $00)
	MOVLW      2
	MOVWF      FARG_EEPROM_Write_address+0
	CLRF       FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;mini siors.mbas,207 :: 		delay_ms(1) 'attendo 1 millisecondo
	MOVLW      2
	MOVWF      R12+0
	MOVLW      75
	MOVWF      R13+0
L_mini_32siors_reset_EEPROM_value42:
	DECFSZ     R13+0, 1
	GOTO       L_mini_32siors_reset_EEPROM_value42
	DECFSZ     R12+0, 1
	GOTO       L_mini_32siors_reset_EEPROM_value42
;mini siors.mbas,208 :: 		EEPROM_Write($03, $FF)
	MOVLW      3
	MOVWF      FARG_EEPROM_Write_address+0
	MOVLW      255
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;mini siors.mbas,209 :: 		delay_ms(1)
	MOVLW      2
	MOVWF      R12+0
	MOVLW      75
	MOVWF      R13+0
L_mini_32siors_reset_EEPROM_value43:
	DECFSZ     R13+0, 1
	GOTO       L_mini_32siors_reset_EEPROM_value43
	DECFSZ     R12+0, 1
	GOTO       L_mini_32siors_reset_EEPROM_value43
;mini siors.mbas,210 :: 		EEPROM_Write($04, $FF)
	MOVLW      4
	MOVWF      FARG_EEPROM_Write_address+0
	MOVLW      255
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;mini siors.mbas,211 :: 		delay_ms(1)
	MOVLW      2
	MOVWF      R12+0
	MOVLW      75
	MOVWF      R13+0
L_mini_32siors_reset_EEPROM_value44:
	DECFSZ     R13+0, 1
	GOTO       L_mini_32siors_reset_EEPROM_value44
	DECFSZ     R12+0, 1
	GOTO       L_mini_32siors_reset_EEPROM_value44
;mini siors.mbas,212 :: 		EEPROM_Write($05, $00)
	MOVLW      5
	MOVWF      FARG_EEPROM_Write_address+0
	CLRF       FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;mini siors.mbas,213 :: 		delay_ms(1)
	MOVLW      2
	MOVWF      R12+0
	MOVLW      75
	MOVWF      R13+0
L_mini_32siors_reset_EEPROM_value45:
	DECFSZ     R13+0, 1
	GOTO       L_mini_32siors_reset_EEPROM_value45
	DECFSZ     R12+0, 1
	GOTO       L_mini_32siors_reset_EEPROM_value45
;mini siors.mbas,214 :: 		EEPROM_Write($06, $00)
	MOVLW      6
	MOVWF      FARG_EEPROM_Write_address+0
	CLRF       FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
	RETURN
; end of mini_32siors_reset_EEPROM_value

mini_32siors_test_in_data:

;mini siors.mbas,218 :: 		sub procedure test_in_data()
;mini siors.mbas,220 :: 		input_value = not read_input()
	CALL       mini_32siors_read_input+0
	COMF       R0+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      _input_value+0
;mini siors.mbas,223 :: 		flag_hi_byte = flag_hi_byte or input_value
	MOVF       R1+0, 0
	IORWF      _flag_hi_byte+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _flag_hi_byte+0
;mini siors.mbas,226 :: 		flag_low_byte = flag_low_byte and input_value
	MOVF       R1+0, 0
	ANDWF      _flag_low_byte+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      _flag_low_byte+0
;mini siors.mbas,228 :: 		if (last_flag_hi_byte <> flag_hi_byte) or (last_flag_low_byte <> flag_low_byte) then
	MOVF       _last_flag_hi_byte+0, 0
	XORWF      R0+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _last_flag_low_byte+0, 0
	XORWF      R2+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L_mini_32siors_test_in_data48
;mini siors.mbas,230 :: 		last_flag_low_byte = flag_low_byte
	MOVF       _flag_low_byte+0, 0
	MOVWF      _last_flag_low_byte+0
;mini siors.mbas,231 :: 		last_flag_hi_byte = flag_hi_byte
	MOVF       _flag_hi_byte+0, 0
	MOVWF      _last_flag_hi_byte+0
;mini siors.mbas,233 :: 		EEPROM_Write($04, flag_low_byte)
	MOVLW      4
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _flag_low_byte+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;mini siors.mbas,234 :: 		EEPROM_Write($05, flag_hi_byte)
	MOVLW      5
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _flag_hi_byte+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
L_mini_32siors_test_in_data48:
;mini siors.mbas,235 :: 		end if
	RETURN
; end of mini_32siors_test_in_data

mini_32siors_tmr1_reset:

;mini siors.mbas,239 :: 		sub procedure tmr1_reset()
;mini siors.mbas,240 :: 		tmr1h = 0
	CLRF       TMR1H+0
;mini siors.mbas,241 :: 		tmr1l = 0
	CLRF       TMR1L+0
;mini siors.mbas,243 :: 		count_tmr1 = 0
	CLRF       _count_tmr1+0
	CLRF       _count_tmr1+1
	RETURN
; end of mini_32siors_tmr1_reset

_main:

;mini siors.mbas,247 :: 		main:
;mini siors.mbas,250 :: 		cmcon = $07 'disabilito modulo CCP
	MOVLW      7
	MOVWF      CMCON+0
;mini siors.mbas,252 :: 		trisa = $F0 'configura gli i/o di porta (bin 11110000)
	MOVLW      240
	MOVWF      TRISA+0
;mini siors.mbas,253 :: 		trisb = $F2 'configura gli i/o di portb (bin 11110010)
	MOVLW      242
	MOVWF      TRISB+0
;mini siors.mbas,255 :: 		porta = 0
	CLRF       PORTA+0
;mini siors.mbas,256 :: 		portb = 0
	CLRF       PORTB+0
;mini siors.mbas,258 :: 		INTCON = $C0
	MOVLW      192
	MOVWF      INTCON+0
;mini siors.mbas,259 :: 		PIE1 = $01
	MOVLW      1
	MOVWF      PIE1+0
;mini siors.mbas,260 :: 		PIR1 = $00
	CLRF       PIR1+0
;mini siors.mbas,261 :: 		T1CON = $34
	MOVLW      52
	MOVWF      T1CON+0
;mini siors.mbas,263 :: 		tmr1_enable = 0
	BCF        T1CON+0, 0
;mini siors.mbas,264 :: 		tmr1_reset()
	CALL       mini_32siors_tmr1_reset+0
;mini siors.mbas,265 :: 		reset_pulse = 0
	CLRF       _reset_pulse+0
;mini siors.mbas,267 :: 		option_reg = $7F
	MOVLW      127
	MOVWF      OPTION_REG+0
;mini siors.mbas,270 :: 		flag_hi_byte = EEPROM_Read($05)
	MOVLW      5
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      _flag_hi_byte+0
;mini siors.mbas,271 :: 		last_flag_hi_byte = flag_hi_byte
	MOVF       R0+0, 0
	MOVWF      _last_flag_hi_byte+0
;mini siors.mbas,272 :: 		flag_low_byte = EEPROM_Read($04)
	MOVLW      4
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      _flag_low_byte+0
;mini siors.mbas,273 :: 		last_flag_low_byte = flag_low_byte
	MOVF       R0+0, 0
	MOVWF      _last_flag_low_byte+0
;mini siors.mbas,275 :: 		uart1_init(9600) 'inizializzazione uart hardware pic a 9600 bps
	MOVLW      25
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;mini siors.mbas,276 :: 		tx_uart_enable = 0 'diasbilita invio seriale
	BCF        TXSTA+0, 5
;mini siors.mbas,277 :: 		rx_uart_enable = 0 'disabilito ricezione seriale
	BCF        RCSTA+0, 4
;mini siors.mbas,279 :: 		adr_m = EEPROM_Read($00) 'address master
	CLRF       FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      _adr_m+0
;mini siors.mbas,280 :: 		adr_s = EEPROM_Read($01) 'address slave
	MOVLW      1
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      _adr_s+0
;mini siors.mbas,283 :: 		write_output(EEPROM_Read($02)) 'ripristina il valore di output precedente
	MOVLW      2
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      FARG_write_output_out_value_w+0
	CALL       mini_32siors_write_output+0
;mini siors.mbas,284 :: 		read_output()
	CALL       mini_32siors_read_output+0
;mini siors.mbas,286 :: 		delay_set = EEPROM_Read($06) * 2
	MOVLW      6
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	CLRF       R1+1
	MOVF       R1+0, 0
	MOVWF      _delay_set+0
	MOVF       R1+1, 0
	MOVWF      _delay_set+1
	RLF        _delay_set+0, 1
	RLF        _delay_set+1, 1
	BCF        _delay_set+0, 0
;mini siors.mbas,289 :: 		led_activity = 1 'attivo led
	BSF        PORTB+0, 3
;mini siors.mbas,290 :: 		delay_ms(750) 'accende led per alcuni ms per avvisare della corretta accensione
	MOVLW      4
	MOVWF      R11+0
	MOVLW      207
	MOVWF      R12+0
	MOVLW      1
	MOVWF      R13+0
L__main52:
	DECFSZ     R13+0, 1
	GOTO       L__main52
	DECFSZ     R12+0, 1
	GOTO       L__main52
	DECFSZ     R11+0, 1
	GOTO       L__main52
	NOP
	NOP
;mini siors.mbas,291 :: 		led_activity = 0 'spegne led
	BCF        PORTB+0, 3
;mini siors.mbas,293 :: 		get_data_received = "" 'azzero dato ricezione
	CLRF       _get_data_received+0
;mini siors.mbas,294 :: 		rx_uart_enable = 1 'riabilita ricezione
	BSF        RCSTA+0, 4
;mini siors.mbas,297 :: 		while true
L__main54:
;mini siors.mbas,298 :: 		clrwdt 'resetto watchdog timer
	CLRWDT
;mini siors.mbas,300 :: 		test_in_data()
	CALL       mini_32siors_test_in_data+0
;mini siors.mbas,303 :: 		if (reset_pulse.0 = 1) then
	BTFSS      _reset_pulse+0, 0
	GOTO       L__main59
;mini siors.mbas,305 :: 		reset_pulse.0 = 0
	BCF        _reset_pulse+0, 0
;mini siors.mbas,307 :: 		write_output(pulse_byte)
	MOVF       _pulse_byte+0, 0
	MOVWF      FARG_write_output_out_value_w+0
	CALL       mini_32siors_write_output+0
L__main59:
;mini siors.mbas,310 :: 		if (UART1_Data_Ready() = 1)  then 'se  stato ricevuto qualche byte da UART
	CALL       _UART1_Data_Ready+0
	MOVF       R0+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main62
;mini siors.mbas,311 :: 		UART1_Read_Text(get_data_received,"",11) 'effettuo la procedura di lettura cercando i 3 byte
	MOVLW      _get_data_received+0
	MOVWF      FARG_UART1_Read_Text_Output+0
	MOVLW      3
	MOVWF      _main_Local_Text+0
	MOVLW      3
	MOVWF      _main_Local_Text+1
	MOVLW      3
	MOVWF      _main_Local_Text+2
	CLRF       _main_Local_Text+3
	MOVLW      _main_Local_Text+0
	MOVWF      FARG_UART1_Read_Text_Delimiter+0
	MOVLW      11
	MOVWF      FARG_UART1_Read_Text_Attempts+0
	CALL       _UART1_Read_Text+0
;mini siors.mbas,313 :: 		rx_uart_enable = 0 'Disabilita modulo ricezione UART (interrompe ricezione durante procedura)
	BCF        RCSTA+0, 4
;mini siors.mbas,314 :: 		delay_ms(2) 'attende 2ms prima della procedura
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L__main64:
	DECFSZ     R13+0, 1
	GOTO       L__main64
	DECFSZ     R12+0, 1
	GOTO       L__main64
	NOP
	NOP
;mini siors.mbas,315 :: 		decode_ric_data(get_data_received, correct_packet, address_packet, adr_sender_test, type_packet, data1_packet, data2_packet)
	MOVLW      _get_data_received+0
	MOVWF      FARG_decode_ric_data_array_in_data+0
	MOVLW      _correct_packet+0
	MOVWF      FARG_decode_ric_data_correct_data+0
	MOVLW      _address_packet+0
	MOVWF      FARG_decode_ric_data_address_ric+0
	MOVLW      _adr_sender_test+0
	MOVWF      FARG_decode_ric_data_address_master+0
	MOVLW      _type_packet+0
	MOVWF      FARG_decode_ric_data_type_ric+0
	MOVLW      _data1_packet+0
	MOVWF      FARG_decode_ric_data_data1_ric+0
	MOVLW      _data2_packet+0
	MOVWF      FARG_decode_ric_data_data2_ric+0
	CALL       mini_32siors_decode_ric_data+0
;mini siors.mbas,316 :: 		if (correct_packet = 1) then
	MOVF       _correct_packet+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main66
;mini siors.mbas,317 :: 		if (adr_s = address_packet) and (adr_sender_test = adr_m) and (program_button = 0) then
	MOVF       _adr_s+0, 0
	XORWF      _address_packet+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _adr_sender_test+0, 0
	XORWF      _adr_m+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	CLRF       R0+0
	BTFSC      PORTA+0, 4
	GOTO       L__main71
	MOVLW      255
	MOVWF      R0+0
L__main71:
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main69
;mini siors.mbas,319 :: 		case 1
	MOVF       _type_packet+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main75
;mini siors.mbas,320 :: 		if (data1_packet = 63) and (data2_packet = 0) then
	MOVF       _data1_packet+0, 0
	XORLW      63
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main77
;mini siors.mbas,321 :: 		code_data_to_send(adr_m,1,33,device_type)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      1
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      33
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVLW      73
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
L__main77:
;mini siors.mbas,322 :: 		end if
	GOTO       L__main72
L__main75:
;mini siors.mbas,325 :: 		case 10
	MOVF       _type_packet+0, 0
	XORLW      10
	BTFSS      STATUS+0, 2
	GOTO       L__main81
;mini siors.mbas,326 :: 		if (data1_packet = 63) and (data2_packet = 0) then
	MOVF       _data1_packet+0, 0
	XORLW      63
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main83
;mini siors.mbas,327 :: 		code_data_to_send(adr_m,10,input_value,0)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      10
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVF       _input_value+0, 0
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
L__main83:
;mini siors.mbas,328 :: 		end if
	GOTO       L__main72
L__main81:
;mini siors.mbas,331 :: 		case 11
	MOVF       _type_packet+0, 0
	XORLW      11
	BTFSS      STATUS+0, 2
	GOTO       L__main87
;mini siors.mbas,332 :: 		if (data1_packet = 63) and (data2_packet = 0) then
	MOVF       _data1_packet+0, 0
	XORLW      63
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main89
;mini siors.mbas,333 :: 		read_output() 'Legge il dato attualmente in output
	CALL       mini_32siors_read_output+0
;mini siors.mbas,334 :: 		code_data_to_send(adr_m,11,out_value_r,0)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      11
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVF       _out_value_r+0, 0
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
L__main89:
;mini siors.mbas,335 :: 		end if
	GOTO       L__main72
L__main87:
;mini siors.mbas,338 :: 		case 12
	MOVF       _type_packet+0, 0
	XORLW      12
	BTFSS      STATUS+0, 2
	GOTO       L__main93
;mini siors.mbas,339 :: 		if (data2_packet = 0) then
	MOVF       _data2_packet+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main95
;mini siors.mbas,340 :: 		write_output(data1_packet) 'scrive il nuovo valore in output
	MOVF       _data1_packet+0, 0
	MOVWF      FARG_write_output_out_value_w+0
	CALL       mini_32siors_write_output+0
;mini siors.mbas,341 :: 		read_output() 'legge il dato in output
	CALL       mini_32siors_read_output+0
;mini siors.mbas,342 :: 		code_data_to_send(adr_m,12,out_value_r,0) 'invia il dato appena letto
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      12
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVF       _out_value_r+0, 0
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
;mini siors.mbas,345 :: 		tmr1_reset()
	CALL       mini_32siors_tmr1_reset+0
;mini siors.mbas,346 :: 		tmr1_enable = 1 'Attiva timer
	BSF        T1CON+0, 0
;mini siors.mbas,350 :: 		pulse_byte = out_value_r and  EEPROM_Read($03) 'confronta i due valori dei registri
	MOVLW      3
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	ANDWF      _out_value_r+0, 0
	MOVWF      _pulse_byte+0
;mini siors.mbas,351 :: 		if (EEPROM_Read($02) <> pulse_byte) then 'se il nuovo valore  diverso da quello
	MOVLW      2
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	XORWF      _pulse_byte+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main98
;mini siors.mbas,353 :: 		EEPROM_Write($02, pulse_byte)
	MOVLW      2
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _pulse_byte+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
L__main98:
;mini siors.mbas,354 :: 		end if
L__main95:
;mini siors.mbas,355 :: 		end if
	GOTO       L__main72
L__main93:
;mini siors.mbas,357 :: 		case 16
	MOVF       _type_packet+0, 0
	XORLW      16
	BTFSS      STATUS+0, 2
	GOTO       L__main102
;mini siors.mbas,358 :: 		if (data1_packet = 63) and (data2_packet = 0) then
	MOVF       _data1_packet+0, 0
	XORLW      63
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main104
;mini siors.mbas,362 :: 		code_data_to_send(adr_m,16,(not flag_low_byte) and $0F, flag_hi_byte and $0F)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      16
	MOVWF      FARG_code_data_to_send_type_s+0
	COMF       _flag_low_byte+0, 0
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVLW      15
	ANDWF      FARG_code_data_to_send_data1_s+0, 1
	MOVLW      15
	ANDWF      _flag_hi_byte+0, 0
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
L__main104:
;mini siors.mbas,363 :: 		end if
	GOTO       L__main72
L__main102:
;mini siors.mbas,366 :: 		case 17
	MOVF       _type_packet+0, 0
	XORLW      17
	BTFSS      STATUS+0, 2
	GOTO       L__main108
;mini siors.mbas,367 :: 		if (data1_packet = 82) then
	MOVF       _data1_packet+0, 0
	XORLW      82
	BTFSS      STATUS+0, 2
	GOTO       L__main110
;mini siors.mbas,369 :: 		case 76 'Reset solo flag LOW
	MOVF       _data2_packet+0, 0
	XORLW      76
	BTFSS      STATUS+0, 2
	GOTO       L__main115
;mini siors.mbas,370 :: 		flag_low_byte = $FF
	MOVLW      255
	MOVWF      _flag_low_byte+0
;mini siors.mbas,371 :: 		code_data_to_send(adr_m,17, 82, 76)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      17
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      82
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVLW      76
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
	GOTO       L__main112
L__main115:
;mini siors.mbas,372 :: 		case 72 'Reset solo flag HIGH
	MOVF       _data2_packet+0, 0
	XORLW      72
	BTFSS      STATUS+0, 2
	GOTO       L__main118
;mini siors.mbas,373 :: 		flag_hi_byte = 0
	CLRF       _flag_hi_byte+0
;mini siors.mbas,374 :: 		code_data_to_send(adr_m,17, 82, 72)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      17
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      82
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVLW      72
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
	GOTO       L__main112
L__main118:
;mini siors.mbas,375 :: 		case 65 'Reset dei due registri
	MOVF       _data2_packet+0, 0
	XORLW      65
	BTFSS      STATUS+0, 2
	GOTO       L__main121
;mini siors.mbas,376 :: 		flag_low_byte = $FF
	MOVLW      255
	MOVWF      _flag_low_byte+0
;mini siors.mbas,377 :: 		flag_hi_byte = 0
	CLRF       _flag_hi_byte+0
;mini siors.mbas,378 :: 		code_data_to_send(adr_m,17, 82, 65)
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      17
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      82
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVLW      65
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
	GOTO       L__main112
L__main121:
L__main112:
;mini siors.mbas,379 :: 		end select
L__main110:
;mini siors.mbas,380 :: 		end if
	GOTO       L__main72
L__main108:
;mini siors.mbas,383 :: 		case 18
	MOVF       _type_packet+0, 0
	XORLW      18
	BTFSS      STATUS+0, 2
	GOTO       L__main124
;mini siors.mbas,384 :: 		if (data1_packet = 63) and (data2_packet = 0) then
	MOVF       _data1_packet+0, 0
	XORLW      63
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main126
;mini siors.mbas,385 :: 		code_data_to_send(adr_m,18, not EEPROM_Read($03), EEPROM_Read($06))
	MOVLW      6
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      FLOC__main+0
	MOVLW      3
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	COMF       R0+0, 0
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      18
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVF       FLOC__main+0, 0
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
L__main126:
;mini siors.mbas,386 :: 		end if
	GOTO       L__main72
L__main124:
;mini siors.mbas,389 :: 		case 19
	MOVF       _type_packet+0, 0
	XORLW      19
	BTFSS      STATUS+0, 2
	GOTO       L__main130
;mini siors.mbas,392 :: 		EEPROM_Write($03, not data1_packet) 'Il valore vine invertito prima di essere memorizzato
	MOVLW      3
	MOVWF      FARG_EEPROM_Write_address+0
	COMF       _data1_packet+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;mini siors.mbas,393 :: 		EEPROM_Write($06, data2_packet)
	MOVLW      6
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _data2_packet+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;mini siors.mbas,394 :: 		code_data_to_send(adr_m,19, data1_packet, data2_packet) 'Invia il contenuto del registro pulse byte nell'EEPROM
	MOVF       _adr_m+0, 0
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      19
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVF       _data1_packet+0, 0
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVF       _data2_packet+0, 0
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
;mini siors.mbas,396 :: 		tmr1_enable = 0
	BCF        T1CON+0, 0
;mini siors.mbas,397 :: 		tmr1_reset()
	CALL       mini_32siors_tmr1_reset+0
;mini siors.mbas,400 :: 		delay_set = data2_packet * 2
	MOVF       _data2_packet+0, 0
	MOVWF      R1+0
	CLRF       R1+1
	MOVF       R1+0, 0
	MOVWF      _delay_set+0
	MOVF       R1+1, 0
	MOVWF      _delay_set+1
	RLF        _delay_set+0, 1
	RLF        _delay_set+1, 1
	BCF        _delay_set+0, 0
;mini siors.mbas,403 :: 		read_output()'Legge gli output dopo la modifica
	CALL       mini_32siors_read_output+0
;mini siors.mbas,404 :: 		pulse_byte = out_value_r and  EEPROM_Read($03)'Azzera i bit impostati come Pulse
	MOVLW      3
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       _out_value_r+0, 0
	ANDWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _pulse_byte+0
;mini siors.mbas,405 :: 		write_output(pulse_byte)'scrive in output il valore con i bit pulse azzerati
	MOVF       R0+0, 0
	MOVWF      FARG_write_output_out_value_w+0
	CALL       mini_32siors_write_output+0
;mini siors.mbas,406 :: 		if (EEPROM_Read($02) <> pulse_byte) then 'Se il valore  diverso da quello presente in eeprom
	MOVLW      2
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	XORWF      _pulse_byte+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main132
;mini siors.mbas,408 :: 		EEPROM_Write($02, pulse_byte)
	MOVLW      2
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _pulse_byte+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
L__main132:
;mini siors.mbas,409 :: 		end if
	GOTO       L__main72
L__main130:
;mini siors.mbas,411 :: 		case 63 'Ricevuto codice errore
	MOVF       _type_packet+0, 0
	XORLW      63
	BTFSS      STATUS+0, 2
	GOTO       L__main136
;mini siors.mbas,412 :: 		if (data1_packet = 2) and (data2_packet = 0) then 'se l'invio precedente era errato (errore 2)
	MOVF       _data1_packet+0, 0
	XORLW      2
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main138
;mini siors.mbas,413 :: 		send_data(last_send_data) 'reinvia l'ultimo dato
	MOVLW      _last_send_data+0
	MOVWF      FARG_send_data_datasend+0
	CALL       mini_32siors_send_data+0
L__main138:
;mini siors.mbas,414 :: 		end if
	GOTO       L__main72
L__main136:
L__main72:
;mini siors.mbas,416 :: 		end select
	GOTO       L__main70
;mini siors.mbas,417 :: 		else
L__main69:
;mini siors.mbas,418 :: 		if (address_packet = 255) and (adr_sender_test = 255) and (program_button = 1) and (type_packet = 60) then
	MOVF       _address_packet+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _adr_sender_test+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	CLRF       R0+0
	BTFSS      PORTA+0, 4
	GOTO       L__main143
	MOVLW      255
	MOVWF      R0+0
L__main143:
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVF       _type_packet+0, 0
	XORLW      60
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main141
;mini siors.mbas,419 :: 		if (data1_packet <> 0) and (data2_packet <> 0) and (data1_packet < 255) and
	MOVF       _data1_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _data2_packet+0, 0
	XORLW      0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVLW      255
	SUBWF      _data1_packet+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
;mini siors.mbas,420 :: 		(data2_packet < 255) and (data1_packet <> data2_packet) then
	MOVLW      255
	SUBWF      _data2_packet+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVF       _data1_packet+0, 0
	XORWF      _data2_packet+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main145
;mini siors.mbas,422 :: 		EEPROM_Write($00, data1_packet)
	CLRF       FARG_EEPROM_Write_address+0
	MOVF       _data1_packet+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;mini siors.mbas,423 :: 		EEPROM_Write($01, data2_packet)
	MOVLW      1
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _data2_packet+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;mini siors.mbas,424 :: 		code_data_to_send(255,60,65,79) 'invia pacchetto programmazione corretta
	MOVLW      255
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      60
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      65
	MOVWF      FARG_code_data_to_send_data1_s+0
	MOVLW      79
	MOVWF      FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
;mini siors.mbas,425 :: 		led_activity = 1
	BSF        PORTB+0, 3
;mini siors.mbas,427 :: 		reset_EEPROM_value()
	CALL       mini_32siors_reset_EEPROM_value+0
;mini siors.mbas,428 :: 		delay_ms(950)
	MOVLW      5
	MOVWF      R11+0
	MOVLW      210
	MOVWF      R12+0
	MOVLW      191
	MOVWF      R13+0
L__main147:
	DECFSZ     R13+0, 1
	GOTO       L__main147
	DECFSZ     R12+0, 1
	GOTO       L__main147
	DECFSZ     R11+0, 1
	GOTO       L__main147
;mini siors.mbas,429 :: 		led_activity = 0
	BCF        PORTB+0, 3
	GOTO       L__main146
;mini siors.mbas,430 :: 		else
L__main145:
;mini siors.mbas,431 :: 		code_data_to_send(255,63,1,0) 'invia pacchetto programmazione errata (errore 1)
	MOVLW      255
	MOVWF      FARG_code_data_to_send_address_master_send+0
	MOVLW      63
	MOVWF      FARG_code_data_to_send_type_s+0
	MOVLW      1
	MOVWF      FARG_code_data_to_send_data1_s+0
	CLRF       FARG_code_data_to_send_data2_s+0
	CALL       mini_32siors_code_data_to_send+0
;mini siors.mbas,432 :: 		led_activity = 1 'avvisa con lampeggio led
	BSF        PORTB+0, 3
;mini siors.mbas,433 :: 		delay_ms(50)
	MOVLW      65
	MOVWF      R12+0
	MOVLW      238
	MOVWF      R13+0
L__main148:
	DECFSZ     R13+0, 1
	GOTO       L__main148
	DECFSZ     R12+0, 1
	GOTO       L__main148
	NOP
;mini siors.mbas,434 :: 		led_activity = 0
	BCF        PORTB+0, 3
;mini siors.mbas,435 :: 		end if
L__main146:
L__main141:
;mini siors.mbas,437 :: 		end if
L__main70:
L__main66:
;mini siors.mbas,439 :: 		get_data_received = "" 'svuoto array valori ricevuti
	CLRF       _get_data_received+0
;mini siors.mbas,440 :: 		rx_uart_enable = 1 'Abilita modulo ricezione UART
	BSF        RCSTA+0, 4
L__main62:
;mini siors.mbas,442 :: 		wend
	GOTO       L__main54
	GOTO       $+0
; end of _main
